/*
 * Program G_Courbe V0.1 or higher
 * (C) by Benjamin Drieu (e-mail: drieu@bocal.cs.univ-paris8.fr)
 * Nov 26rd 1997
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public Licences as published
 * by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will entertaining,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of 
 * MERCHANTABILTY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General
 * Publis License for more details.
 *
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.
 * 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */

/* Inclusion du fichier en-tete de la librairie Grafik */
#include "grafik.h"
#include <math.h>

#define ECHELLE 1
#define UNITE 10


void 
dessinerReperes ()
{
  int i;

  for (i=UNITE-1; i<G_WIDTH; i+=UNITE)
    {
      G_dessinerPoint (i, G_HEIGHT/2-1);
    }
  for (i=UNITE-1; i<G_WIDTH; i+=UNITE)
    {
      G_dessinerPoint (G_WIDTH/2+1, i);
    }
}



void
dessinerCourbe ()
{
  double t;
  int oldX=0, oldY=0;
  int newX=0, newY=0;

  for (t=0; t<31.4; t+=.1) 
    {
      newX=cos(t)*t*UNITE;
      newY=sin(t)*t*UNITE;
      G_changerCouleurRGB ((int)(t*10)%256, 0, 0); 
      G_dessinerLigne (oldX, oldY, newX, newY); 
      oldX=newX;
      oldY=newY;
    }
}



void
main (int argc, char ** argv) 
{
  /* Initialisation des parametres X. Le parametre passe en argument
     est le display. Par commodite, nous mettons ici le premier
     argument passe a la ligne de commande, ce qui permet de lancer le
     programme sur n'importe quel display: "clic merlin:0.0" */
  G_init (argv[1]);

  /* Ici on ouvre la fenetre, on lui donne un titre et des dimensions
   */ 
  G_ouvrirFenetre ("Exemple de gestion d'evenements", 600, 600);

  G_dessinerLigne (0, G_WIDTH/2, G_HEIGHT, G_WIDTH/2);
  G_dessinerLigne (G_WIDTH/2, 0, G_HEIGHT/2, G_WIDTH);
  dessinerReperes ();

  G_setRepere (G_WIDTH/2, G_HEIGHT/2);

  G_changerEpaisseur (2);
  dessinerCourbe ();

  /* Il ne reste plus qu'a faire le lancement de  la boucle
     d'interception d'evenements Grafiks. C'est une fonction bloquante,
     qui ne rend pas la main au programme */
  G_executer ();
}


