/*
 * Program G_Fenetres V0.2 or higher
 * (C) by Benjamin Drieu (e-mail: drieu@bocal.cs.univ-paris8.fr)
 * Nov 26rd 1997
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public Licences as published
 * by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will entertaining,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of 
 * MERCHANTABILTY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General
 * Publis License for more details.
 *
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.
 * 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */

#include <stdio.h>
#include <stdlib.h>
#include "grafik.h"


#define MAX_FENETRES 5 
#define MAX_COULEURS 6

String couleurs[MAX_COULEURS]={
  "Red", "Green", "Blue", "Yellow", "Pink", "PeachPuff", 
};
int indices [MAX_FENETRES];
G_Fenetre *un, *deux;


void changerCouleur (G_Fenetre *, int, int, String);
void ouvrirFenetre (G_Fenetre *, int, int, String);
void fermerFenetre (G_Fenetre *, int, int, String);


void
changerCouleur (G_Fenetre *fenetre, int x, int y, String params)
{
  G_changeFenetre (fenetre);
  indices[fenetre->position]= (indices[fenetre->position]+1)%MAX_COULEURS; 
  G_changerCouleur (couleurs[indices[fenetre->position]]);
  G_dessinerRectanglePlein (0, 0, G_WIDTH, G_HEIGHT);
}



void
ouvrirFenetre (G_Fenetre *fenetre, int x, int y, String params)
{
  int i;

  for (i=0; i<MAX_FENETRES; i++)
    {
      if (indices[i] == -1)
	{
	  G_ouvrirFenetre ("Fenetre", 100, 100);
	  G_ajouterEvenement (G_Clic1, changerCouleur);
	  G_ajouterEvenement (G_Clic2, ouvrirFenetre);
	  G_ajouterEvenement (G_Clic3, fermerFenetre);
	  indices[i]=0;
	  return;
	}
    }
}



void
fermerFenetre (G_Fenetre *fenetre, int x, int y, String params)
{
  indices[fenetre->position]=-1;
  G_fermerFenetre (fenetre);
}



void 
main (int argc, char **argv)
{
  int i;

  if (argc != 2 || (atoi(argv[1])<1 || atoi(argv[1])>MAX_FENETRES))
    {
      fprintf (stderr, "Usage: %s <nombre>\n\tnombre entre 1 et %d\n",
	       argv[0], MAX_FENETRES); 
      exit (0);
    }

  G_init ("");

  for (i=0; i<MAX_FENETRES; i++)
    indices[i]=-1;

  for (i=0; i<atoi(argv[1]); i++)
    {
      G_ouvrirFenetre ("Fenetre", 100, 100);
      G_ajouterEvenement (G_Clic1, changerCouleur);
      G_ajouterEvenement (G_Clic2, ouvrirFenetre);
      G_ajouterEvenement (G_Clic3, fermerFenetre);
      indices[i]=0;
    }

  G_executer ();

}
