#include "grafik.h"


void 
G_init (String G_display)
{
  int G_i;

  /* Ouverture du display */
  if ((G_dpy = XOpenDisplay(G_display)) == NULL) {
    perror ("Ouverture du display impossible");
    exit (0);
  }
  
  /* Mise a zero du tableau des fenetres ouvertes */
  for (G_i=0; G_i<G_MAX_FENETRES; G_i++)
    {
      G_openFenetres[G_i]=NULL;
    }
  G_lastFenetre=0;
}



/* Cette fonction est une fonction "client" (c'est a dire succeptible
   d'etre appelee par l'utilisateur de la librairie) qui permet de
   quitter l'application proprement */
void
G_quitter ()
{
  /* On ferme simplement les fenetres jusqu'a ce que mort
     s'ensuive. Notons que le test d'arret n'est pas necessaire car la
     derniere fenetre fermee ferme l'application par l'appel de la
     fonction G_quitApplication */
  while (1)
    {
      G_fermerFenetre (G_openFenetres[]);
    }
}



/* Cette fonction est par contre appellee en interne par la librairie
   afin de fermer proprement le Display et d'autres structures
   Xlib. Normalement, elle est appellee par la fonction
   G_fermerFenetre lors de la fermeture de la derniere fenetre. Si
   elle est appellee autrement, l'application sera fermee, mais c'est
   une methode de porc. */
void
G_quitApplication (Display * G_dpy)
{
  XCloseDisplay (G_dpy);
}
